/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-react-core/ES5/Brush";
import { DependencyProperty } from "igniteui-react-core/ES5/DependencyProperty";
import { Series } from "./Series";
import { Thickness } from "igniteui-react-core/ES5/Thickness";
import { Visibility_$type } from "igniteui-react-core/ES5/Visibility";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-react-core/ES5/List$1";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-react-core/ES5/Dictionary$2";
import { Pool$1 } from "igniteui-react-core/ES5/Pool$1";
import { AxisAnnotation } from "./AxisAnnotation";
import { Type, Number_$type, enumGetBox, fromEnum, Point_$type, markType, runOn } from "igniteui-react-core/ES5/type";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { Tuple$2 } from "igniteui-react-core/ES5/Tuple$2";
import { Path } from "igniteui-react-core/ES5/Path";
import { PathGeometry } from "igniteui-react-core/ES5/PathGeometry";
import { PathFigure } from "igniteui-react-core/ES5/PathFigure";
import { LineSegment } from "igniteui-react-core/ES5/LineSegment";
import { PropertyMetadata } from "igniteui-react-core/ES5/PropertyMetadata";
import { isNaN_ } from "igniteui-react-core/ES5/number";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { TranslateTransform } from "igniteui-react-core/ES5/TranslateTransform";
import { LineGeometry } from "igniteui-react-core/ES5/LineGeometry";
import { BrushUtil } from "igniteui-react-core/ES5/BrushUtil";
/**
 * @hidden
 */
var CrosshairLayer = /** @class */ (function (_super) {
    tslib_1.__extends(CrosshairLayer, _super);
    function CrosshairLayer() {
        var _this = _super.call(this) || this;
        _this.xAxisAnnotationFormatLabel = null;
        _this.yAxisAnnotationFormatLabel = null;
        _this.m5 = null;
        _this.m4 = null;
        var a = new CrosshairLayerFrame();
        var b = new CrosshairLayerFrame();
        var c = new CrosshairLayerFrame();
        var d = _this.ff / 1000;
        _this.lv = a;
        _this.lu = b;
        _this.lw = c;
        _this.ab = CrosshairLayer.$;
        return _this;
    }
    CrosshairLayer.prototype.bf = function () {
        return new CrosshairLayerView(this);
    };
    CrosshairLayer.prototype.im = function (a) {
        _super.prototype.im.call(this, a);
        this.mx = a;
    };
    CrosshairLayer.prototype.mz = function () {
        return this.xAxisAnnotationFormatLabel != null;
    };
    CrosshairLayer.prototype.m0 = function () {
        return this.yAxisAnnotationFormatLabel != null;
    };
    Object.defineProperty(CrosshairLayer.prototype, "o9", {
        get: function () {
            return new Thickness(1, this.m7, this.m9, this.m8, this.m6);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CrosshairLayer.prototype, "pa", {
        get: function () {
            return new Thickness(1, this.nc, this.ne, this.nd, this.nb);
        },
        enumerable: true,
        configurable: true
    });
    CrosshairLayer.prototype.mc = function (a, b) {
        if (this.my == null || this.my == a) {
            if (!this.aq.c) {
                this.i6(b);
            }
        }
    };
    CrosshairLayer.prototype.me = function (a, b) {
        var e_1, _a;
        _super.prototype.me.call(this, a, b);
        var c = a;
        var d = this.m3;
        var e = this.m2;
        c.ad.clear();
        c.ae.clear();
        c.ac.clear();
        c.af.clear();
        AxisAnnotationFrameManager.b(c);
        if (this.lz(this.my)) {
            this.n9(this.my, c, d, e);
        }
        else {
            try {
                for (var _b = tslib_1.__values(fromEnum(this.bs.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    if (this.lz(f)) {
                        this.n9(f, c, d, e);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
    };
    CrosshairLayer.prototype.lz = function (a) {
        if (!_super.prototype.lz.call(this, a)) {
            return false;
        }
        var b = this.l7(a);
        if (!b.c) {
            return false;
        }
        return true;
    };
    CrosshairLayer.prototype.ig = function () {
        _super.prototype.ig.call(this);
        if (!this.aq.c && !this.ca()) {
            return;
        }
        if (this.ca()) {
            this.oa(this.lw, false);
        }
        else {
            this.oa(this.lu, false);
        }
    };
    CrosshairLayer.prototype.n9 = function (a, b, c, d) {
        var e = this.l7(a);
        if (!e.c) {
            return;
        }
        var f = e.d;
        f = a.le(f, c, d);
        var g = this.kw;
        if (g == null) {
            g = this.ky;
        }
        if (g == null) {
            g = a.kw;
            if (g != null) {
                g = this.mx.b8(g);
            }
        }
        var h = g;
        var i = g;
        if (this.o1 != null) {
            h = this.o1;
        }
        if (this.o2 != null) {
            i = this.o2;
        }
        b.ac.add(h);
        b.af.add(i);
        b.ad.add(f.y);
        b.ae.add(f.x);
        if (this.m1) {
            AxisAnnotationFrameManager.c(b, f, a, this.bs, this.getEffectiveViewport(), g, this.o3, this.o5, this.o4, this.o9, this.na, this.o6, this.o8, this.o7, this.pa, this.nf, this.pc == 0, this.pb == 0);
        }
    };
    CrosshairLayer.prototype.oa = function (a, b) {
        var c = false;
        if (this.m4 == null) {
            c = true;
            this.m5 = new List$1(Axis.$, 0);
            this.m4 = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(this, a, c, this.m4, this.m5, b, this.ng, this.nh, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
    };
    CrosshairLayer.prototype.n8 = function (a, b, c, d, e) {
        var f = a.item(b);
        b++;
        if (e) {
            f._stroke = d.af._inner[c];
            f._fill = d.af._inner[c];
        }
        else {
            f._stroke = d.ac._inner[c];
            f._fill = d.ac._inner[c];
        }
        f.ac = this.ev;
        f.ai = this.k4;
        f.ad = this.k5;
        return new Tuple$2(Path.$, Number_$type, f, b);
    };
    CrosshairLayer.prototype.mh = function (a, b) {
        _super.prototype.mh.call(this, a, b);
        var c = this.mx.b2;
        var d = a;
        var e = d.ad.count;
        var f = 0;
        var g = b.br.left;
        var h = b.br.right;
        var i = b.br.top;
        var j = b.br.bottom;
        var k = this.pc == 0;
        var l = this.pb == 0;
        for (var m = 0; m < e; m++) {
            var n = Math.floor(d.ad._inner[m]);
            var o = Math.floor(d.ae._inner[m]);
            var p = null;
            if (k) {
                if (isNaN_(n)) {
                    continue;
                }
                var q = this.n8(c, f, m, d, true);
                p = q.c;
                f = q.d;
                var r = new PathGeometry();
                var s = new PathFigure();
                s._startPoint = { $type: Point_$type, x: o, y: i };
                var t = new LineSegment(1);
                t.c = { $type: Point_$type, x: o, y: j };
                s._segments.add(t);
                r.b.add(s);
                p.aj = r;
            }
            if (l) {
                if (isNaN_(n)) {
                    continue;
                }
                var u = this.n8(c, f, m, d, false);
                p = u.c;
                f = u.d;
                var v = new PathGeometry();
                var w = new PathFigure();
                w._startPoint = { $type: Point_$type, x: g, y: n };
                var x = new LineSegment(1);
                x.c = { $type: Point_$type, x: h, y: n };
                w._segments.add(x);
                v.b.add(w);
                p.aj = v;
            }
        }
        c.count = f;
        if (this.ca()) {
            this.oa(this.lw, true);
        }
        else {
            this.oa(this.lu, false);
        }
    };
    CrosshairLayer.prototype.c7 = function () {
        return true;
    };
    CrosshairLayer.prototype.is = function (a, b, c, d) {
        _super.prototype.is.call(this, a, b, c, d);
        switch (b) {
            case CrosshairLayer.$$p[1]:
                this.i6(true);
                break;
            case CrosshairLayer.$$p[7]:
                this.i6(true);
                break;
            case CrosshairLayer.$$p[4]:
                this.i6(true);
                break;
            case CrosshairLayer.$$p[2]:
            case CrosshairLayer.$$p[8]:
            case CrosshairLayer.$$p[10]:
            case CrosshairLayer.$$p[12]:
            case CrosshairLayer.$$p[14]:
            case CrosshairLayer.$$p[13]:
            case CrosshairLayer.$$p[11]:
            case CrosshairLayer.$$p[15]:
            case CrosshairLayer.$$p[16]:
            case CrosshairLayer.$$p[17]:
            case CrosshairLayer.$$p[19]:
            case CrosshairLayer.$$p[21]:
            case CrosshairLayer.$$p[23]:
            case CrosshairLayer.$$p[22]:
            case CrosshairLayer.$$p[20]:
            case CrosshairLayer.$$p[24]:
            case CrosshairLayer.$$p[25]:
            case CrosshairLayer.$$p[0]:
            case CrosshairLayer.$$p[6]:
            case CrosshairLayer.$$p[5]:
                this.i6(true);
                break;
        }
    };
    CrosshairLayer.$t = markType(CrosshairLayer, 'CrosshairLayer', AnnotationLayer.$);
    return CrosshairLayer;
}(AnnotationLayer));
export { CrosshairLayer };
Type.dep(DependencyProperty, PropertyMetadata, CrosshairLayer, 'raisePropertyChanged', ['HorizontalLineStroke:o1:ob', [Brush.$, null], 'HorizontalLineVisibility:pb:oc', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'IsAxisAnnotationEnabled:m1:od', [0, false], 'SkipUnknownValues:m2:oe', [0, true], 'TargetSeries:my:of', [Series.$, null], 'UseInterpolation:m3:og', [0, true], 'VerticalLineStroke:o2:oh', [Brush.$, null], 'VerticalLineVisibility:pc:oi', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'XAxisAnnotationBackground:o3:oj', [Brush.$, null], 'XAxisAnnotationInterpolatedValuePrecision:ng:ok', [1, -1], 'XAxisAnnotationOutline:o4:ol', [Brush.$, null], 'XAxisAnnotationPaddingBottom:m6:om', [1, NaN], 'XAxisAnnotationPaddingLeft:m7:on', [1, NaN], 'XAxisAnnotationPaddingRight:m8:oo', [1, NaN], 'XAxisAnnotationPaddingTop:m9:op', [1, NaN], 'XAxisAnnotationStrokeThickness:na:oq', [1, NaN], 'XAxisAnnotationTextColor:o5:or', [Brush.$, null], 'YAxisAnnotationBackground:o6:os', [Brush.$, null], 'YAxisAnnotationInterpolatedValuePrecision:nh:ot', [1, -1], 'YAxisAnnotationOutline:o7:ou', [Brush.$, null], 'YAxisAnnotationPaddingBottom:nb:ov', [1, NaN], 'YAxisAnnotationPaddingLeft:nc:ow', [1, NaN], 'YAxisAnnotationPaddingRight:nd:ox', [1, NaN], 'YAxisAnnotationPaddingTop:ne:oy', [1, NaN], 'YAxisAnnotationStrokeThickness:nf:oz', [1, NaN], 'YAxisAnnotationTextColor:o8:o0', [Brush.$, null]]);
/**
 * @hidden
 */
var CrosshairLayerView = /** @class */ (function (_super) {
    tslib_1.__extends(CrosshairLayerView, _super);
    function CrosshairLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b1 = null;
        _this.b2 = null;
        _this.b3 = null;
        _this.b1 = a;
        _this.b3 = new List$1(Path.$, 0);
        return _this;
    }
    CrosshairLayerView.prototype.ap = function () {
        var _this = this;
        _super.prototype.ap.call(this);
        this.b2 = ((function () {
            var $ret = new Pool$1(Path.$);
            $ret.create = runOn(_this, _this.b9);
            $ret.activate = runOn(_this, _this.b4);
            $ret.disactivate = runOn(_this, _this.b6);
            $ret.destroy = runOn(_this, _this.b5);
            return $ret;
        })());
    };
    CrosshairLayerView.prototype.b9 = function () {
        var a = new Path();
        a.j = new TranslateTransform();
        this.b3.add(a);
        return a;
    };
    CrosshairLayerView.prototype.b4 = function (a) {
        a._visibility = 0;
    };
    CrosshairLayerView.prototype.b6 = function (a) {
        a._visibility = 1;
    };
    CrosshairLayerView.prototype.b5 = function (a) {
        this.b3.remove(a);
    };
    CrosshairLayerView.prototype.b7 = function (a, b, c, d) {
        if (a.aj == null || a.aj.b.x != d || a.aj.c.x != c) {
            var e = ((function () {
                var $ret = new LineGeometry();
                $ret.c = { $type: Point_$type, x: c, y: b };
                $ret.b = { $type: Point_$type, x: d, y: b };
                return $ret;
            })());
            a.aj = e;
        }
    };
    CrosshairLayerView.prototype.b8 = function (a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.h(a, 0.1);
    };
    CrosshairLayerView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d && !b) {
            for (var c = 0; c < this.b3.count; c++) {
                var d = this.b3._inner[c];
                if (d._visibility == 0) {
                    a.s(d);
                }
            }
        }
    };
    CrosshairLayerView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        for (var b = 0; b < this.b3.count; b++) {
            this.e.a2.exportPathData(a, this.b3._inner[b], "crosshairLine", ["Main", "Crosshair"]);
        }
    };
    CrosshairLayerView.$t = markType(CrosshairLayerView, 'CrosshairLayerView', AnnotationLayerView.$);
    return CrosshairLayerView;
}(AnnotationLayerView));
export { CrosshairLayerView };
